## openconnect 6.00

=== android/Makefile ===
#
# This Makefile attempts to build OpenConnect and its dependencies for Android
#
# It doesn't do a stunning job of tracking changes in the dependencies and
# automatically rebuilding them, but it's good enough for getting them built
# and installed into its own local sysroot.
#
# As long as you have the Android NDK toolchain on your path, you should then
# be able to edit fairly much anything in place and rebuild it locally.
#
# It should also be fairly simple to extend this to cross-compile for any target

NDK     := /opt/android-sdk-linux_x86/android-ndk-r9b/
ARCH    := arm

# You should be able to just 'make ARCH=x86' and it should DTRT.
ifeq ($(ARCH),arm)
TRIPLET := arm-linux-androideabi
OPENSSL_TARGET := android-armv7
EXTRA_CFLAGS := -march=armv7-a
endif
ifeq ($(ARCH),x86)
TRIPLET := i686-linux-android
OPENSSL_TARGET := android-x86
endif
ifeq ($(ARCH),mips)
TRIPLET := mipsel-linux-android
OPENSSL_TARGET := android
EXTRA_LDFLAGS := -lz
endif

TOPDIR := $(shell pwd)
DESTDIR := $(TOPDIR)/$(TRIPLET)/out

TOOLCHAIN := $(TOPDIR)/$(TRIPLET)/toolchain
TOOLCHAIN_BUILT := $(TOOLCHAIN)/.built
TOOLCHAIN_OPTS := --platform=android-14 --arch=$(ARCH) \
		  --install-dir=$(TOOLCHAIN)
PATH := $(TOOLCHAIN)/bin:$(PATH)

OC_SYSROOT := $(TOOLCHAIN)/sysroot/usr
PKG_CONFIG_LIBDIR := $(OC_SYSROOT)/lib/pkgconfig

export PATH PKG_CONFIG_LIBDIR

MAKEINSTALL=$(MAKE) INSTALL=$(TOPDIR)/install_symlink.sh
FETCH=$(TOPDIR)/fetch.sh

CONFIGURE_ARGS := --host=$(TRIPLET) --prefix=$(OC_SYSROOT) \
		  --disable-shared --enable-static \
		  CFLAGS="$(EXTRA_CFLAGS)"

SOURCE_LIST = $(LIBXML2_SRC)/configure $(GMP_SRC)/configure \
	$(NETTLE_SRC)/configure $(GNUTLS_SRC)/configure \
	$(TOMCRYPT_DIR)/makefile $(STOKEN_SRC)/configure \
	$(OATH_SRC)/configure

PKG_LIST := LIBXML2 OPENSSL GMP NETTLE GNUTLS TOMCRYPT STOKEN OATH

MIRROR_TEST_TARGETS := $(addprefix mirror-test-,$(PKG_LIST))

all: openconnect

#####################################################################
#
# Install a local cross toolchain + sysroot
#
# (The fallback logic is because NDK versions <= r8e can fail after trying to
# use 32-bit binaries on a 64-bit NDK installation.)
#
$(TOOLCHAIN_BUILT):
	mkdir -p $(TOOLCHAIN)
	$(NDK)/build/tools/make-standalone-toolchain.sh $(TOOLCHAIN_OPTS) || \
		$(NDK)/build/tools/make-standalone-toolchain.sh \
			$(TOOLCHAIN_OPTS) --system=linux-x86_64
	touch $@

#####################################################################
#
# Build libxml2 with minimal configuration for OpenConnect
#
LIBXML2_VER := 2.9.0
LIBXML2_TAR := libxml2-$(LIBXML2_VER).tar.gz
LIBXML2_SHA1 := a43d7c0a8e463ac5a7846254f2a732a9af146fab
LIBXML2_SRC := sources/libxml2-$(LIBXML2_VER)
LIBXML2_BUILD := $(TRIPLET)/libxml2

$(LIBXML2_TAR):
	$(FETCH) $@ $(LIBXML2_SHA1)

$(LIBXML2_SRC)/configure: $(LIBXML2_TAR)
	mkdir -p sources
	tar xfz $<  -C sources
	touch $@

$(LIBXML2_BUILD)/Makefile: $(TOOLCHAIN_BUILT) $(LIBXML2_SRC)/configure
	mkdir -p $(LIBXML2_BUILD)
	cd $(LIBXML2_BUILD) && ../../$(LIBXML2_SRC)/configure $(CONFIGURE_ARGS) \
	    --without-c14n -without-catalog --without-debug --without-docbook \
	    --without-fexceptions --without-ftp --without-history \
	    --without-html --without-http --without-iconv --without-iconv \
	    --without-iso8859x --without-legacy --without-pattern \
	    --without-push --without-regexps --without-run-debug \
	    --without-sax1 --without-schemas --without-schematron \
	    --without-threads --without-valid --without-xinclude \
	    --without-xpath --without-xptr --without-zlib --without-lzma \
	    --without-coverage --without-python

$(LIBXML2_BUILD)/libxml2.la: $(LIBXML2_BUILD)/Makefile
	$(MAKE) -C $(LIBXML2_BUILD) libxml2.la

$(LIBXML2_BUILD)/libxml-2.0.pc: $(LIBXML2_BUILD)/Makefile
	$(MAKE) -C $(LIBXML2_BUILD) libxml-2.0.pc

$(OC_SYSROOT)/lib/libxml2.la: $(LIBXML2_BUILD)/libxml2.la
	$(MAKEINSTALL) -C $(LIBXML2_BUILD) install-libLTLIBRARIES

$(OC_SYSROOT)/lib/pkgconfig/libxml-2.0.pc: $(LIBXML2_BUILD)/libxml-2.0.pc
	$(MAKEINSTALL) -C $(LIBXML2_BUILD) install-data

LIBXML_DEPS := $(OC_SYSROOT)/lib/libxml2.la $(OC_SYSROOT)/lib/pkgconfig/libxml-2.0.pc

libxml: $(LIBXML_DEPS)


#####################################################################
#
# Build OpenSSL for Android
#
OPENSSL_VER := 1.0.1g
OPENSSL_TAR := openssl-$(OPENSSL_VER).tar.gz
OPENSSL_SHA1 := b28b3bcb1dc3ee7b55024c9f795be60eb3183e3c
OPENSSL_DIR := $(TRIPLET)/openssl-$(OPENSSL_VER)

$(OPENSSL_TAR):
	$(FETCH) $@ $(OPENSSL_SHA1)

$(OPENSSL_DIR)/Configure: $(OPENSSL_TAR)
	mkdir -p $(TRIPLET)
	tar xfz $< -C $(TRIPLET)
	touch $(OPENSSL_DIR)/Configure # Make sure it's newer than Makefile and tarball

$(OPENSSL_DIR)/Makefile: $(TOOLCHAIN_BUILT) $(OPENSSL_DIR)/Configure
	cd $(OPENSSL_DIR) && perl Configure --prefix=$(OC_SYSROOT) \
		--cross-compile-prefix=$(TRIPLET)- no-shared \
		$(OPENSSL_TARGET):gcc

$(OPENSSL_DIR)/libssl.a: $(OPENSSL_DIR)/Makefile
	$(MAKE) -C $(OPENSSL_DIR)

$(OC_SYSROOT)/lib/libssl.a: $(OPENSSL_DIR)/libssl.a
	# Do this manually instead of using 'make install' since we want symlinks
	mkdir -p $(OC_SYSROOT)/include/openssl
	ln -sf $(shell pwd)/$(OPENSSL_DIR)/include/openssl/*.h $(OC_SYSROOT)/include/openssl
	mkdir -p $(OC_SYSROOT)/lib/pkgconfig
	ln -sf $(shell pwd)/$(OPENSSL_DIR)/*.pc $(OC_SYSROOT)/lib/pkgconfig
	ln -sf $(shell pwd)/$(OPENSSL_DIR)/*.a $(OC_SYSROOT)/lib

OPENSSL_DEPS := $(OC_SYSROOT)/lib/libssl.a

openssl: $(OPENSSL_DEPS)

#####################################################################
#
# Build GNU MP
#
GMP_VER := 5.1.2
GMP_TAR := gmp-$(GMP_VER).tar.bz2
GMP_SHA1 := 2cb498322b9be4713829d94dee944259c017d615
GMP_SRC := sources/gmp-$(GMP_VER)
GMP_BUILD := $(TRIPLET)/gmp

$(GMP_TAR):
	$(FETCH) $@ $(GMP_SHA1)

$(GMP_SRC)/configure: $(GMP_TAR)
	mkdir -p sources
	tar xfj $< -C sources
	touch $@

$(GMP_BUILD)/Makefile: $(TOOLCHAIN_BUILT) $(GMP_SRC)/configure
	mkdir -p $(GMP_BUILD)
	cd $(GMP_BUILD) && ../../$(GMP_SRC)/configure $(CONFIGURE_ARGS) 


$(GMP_BUILD)/libgmp.la: $(GMP_BUILD)/Makefile
	$(MAKE) -C $(GMP_BUILD)

$(OC_SYSROOT)/lib/libgmp.la: $(GMP_BUILD)/libgmp.la
	$(MAKEINSTALL) -C $(GMP_BUILD) install

GMP_DEPS := $(OC_SYSROOT)/lib/libgmp.la

gmp: $(GMP_DEPS)


#####################################################################
#
# Build nettle
#
NETTLE_VER := 2.7
NETTLE_TAR := nettle-$(NETTLE_VER).tar.gz
NETTLE_SHA1 := e17de3678b987841e88a724b7d2f6856d97ab139
NETTLE_SRC := sources/nettle-$(NETTLE_VER)
NETTLE_BUILD := $(TRIPLET)/nettle

$(NETTLE_TAR):
	$(FETCH) $@ $(NETTLE_SHA1)

$(NETTLE_SRC)/configure: $(NETTLE_TAR)
	mkdir -p sources
	tar xfz $< -C sources
	touch $@

$(NETTLE_BUILD)/Makefile: $(TOOLCHAIN_BUILT) $(NETTLE_SRC)/configure $(GMP_DEPS)
	mkdir -p $(NETTLE_BUILD)
	cd $(NETTLE_BUILD) && ../../$(NETTLE_SRC)/configure $(CONFIGURE_ARGS)

$(NETTLE_BUILD)/libnettle.a: $(NETTLE_BUILD)/Makefile
	$(MAKE) -C $(NETTLE_BUILD) SUBDIRS=

$(OC_SYSROOT)/lib/libnettle.a: $(NETTLE_BUILD)/libnettle.a
	$(MAKEINSTALL) -C $(NETTLE_BUILD) SUBDIRS= install

NETTLE_DEPS := $(OC_SYSROOT)/lib/libnettle.a

nettle: $(NETTLE_DEPS)


#####################################################################
#
# Build GnuTLS
#
GNUTLS_VER := 3.2.15
GNUTLS_TAR := gnutls-$(GNUTLS_VER).tar.xz
GNUTLS_SHA1 := 31f289b48b0bf054f5f8c16d3b878615d0ae06fc
GNUTLS_SRC := sources/gnutls-$(GNUTLS_VER)
GNUTLS_BUILD := $(TRIPLET)/gnutls

$(GNUTLS_TAR):
	$(FETCH) $@ $(GNUTLS_SHA1)

$(GNUTLS_SRC)/configure: $(GNUTLS_TAR)
	mkdir -p sources
	xz -d < $< | tar xf - -C sources
	touch $@

#$(GNUTLS_SRC)/configure.ac:
#	mkdir -p sources
#	cd sources && git clone git://gitorious.org/gnutls/gnutls.git

#$(GNUTLS_SRC)/configure: $(GNUTLS_SRC)/configure.ac
#	touch $(GNUTLS_SRC)/ChangeLog
#	cd $(GNUTLS_SRC) && autoreconf -fvi

$(GNUTLS_BUILD)/Makefile: $(TOOLCHAIN_BUILT) $(GNUTLS_SRC)/configure $(NETTLE_DEPS)
	mkdir -p $(GNUTLS_BUILD)
	cd $(GNUTLS_BUILD) && ../../$(GNUTLS_SRC)/configure $(CONFIGURE_ARGS) \
		AUTOGEN=/bin/true \
		--disable-threads --disable-tests --without-zlib --disable-nls \
		--disable-doc --disable-openssl-compatibility --disable-cxx \
		--disable-openssl-compatibility --disable-ocsp \
		--disable-openpgp-authentication --disable-anon-authentication \
		--disable-psk-authentication --disable-srp-authentication \
		--disable-dtls-srtp-support  --enable-dhe --enable-ecdhe \
		--disable-rsa-export

$(GNUTLS_BUILD)/lib/libgnutls.la: $(GNUTLS_BUILD)/Makefile
	$(MAKE) -C $(GNUTLS_BUILD)

$(OC_SYSROOT)/lib/libgnutls.la: $(GNUTLS_BUILD)/lib/libgnutls.la
	$(MAKEINSTALL) -C $(GNUTLS_BUILD) install

GNUTLS_DEPS := $(OC_SYSROOT)/lib/libgnutls.la

gnutls: $(GNUTLS_DEPS)


#####################################################################
#
# Build libtomcrypt
#
TOMCRYPT_VER := 1.17
TOMCRYPT_TAR := crypt-$(TOMCRYPT_VER).tar.bz2
TOMCRYPT_SHA1 := 9c746822c84e4276e432b64964f94d1d5ddd13ad
TOMCRYPT_DIR := $(TRIPLET)/libtomcrypt-$(TOMCRYPT_VER)

$(TOMCRYPT_TAR):
	$(FETCH) $@ $(TOMCRYPT_SHA1)

$(TOMCRYPT_DIR)/makefile: $(TOMCRYPT_TAR)
	mkdir -p $(TRIPLET)
	tar xfj $< -C $(TRIPLET)
	touch $@

$(TOMCRYPT_DIR)/libtomcrypt.a: $(TOOLCHAIN_BUILT) $(TOMCRYPT_DIR)/makefile
	$(MAKE) -C $(TOMCRYPT_DIR) \
		CC="$(TRIPLET)-gcc $(EXTRA_CFLAGS)" \
		AR="$(TRIPLET)-ar" \
		RANLIB="$(TRIPLET)-ranlib"

$(OC_SYSROOT)/lib/libtomcrypt.a: $(TOMCRYPT_DIR)/libtomcrypt.a
	$(MAKE) -C $(TOMCRYPT_DIR) \
		DESTDIR=$(OC_SYSROOT) \
		LIBPATH=/lib INCPATH=/include \
		INSTALL_USER=$(shell id -u) \
		INSTALL_GROUP=$(shell id -g) \
		NODOCS=1 install

TOMCRYPT_DEPS := $(OC_SYSROOT)/lib/libtomcrypt.a

tomcrypt: $(TOMCRYPT_DEPS)


#####################################################################
#
# Build libstoken
#
STOKEN_VER := 0.5
STOKEN_TAR := stoken-$(STOKEN_VER).tar.gz
STOKEN_SHA1 := 1fcc026580a3cf28904212f34ae2cf2180586f86
STOKEN_SRC := sources/stoken-$(STOKEN_VER)
STOKEN_BUILD := $(TRIPLET)/stoken

$(STOKEN_TAR):
	$(FETCH) $@ $(STOKEN_SHA1)

$(STOKEN_SRC)/configure: $(STOKEN_TAR)
	mkdir -p sources
	tar xfz $< -C sources
	touch $@

$(STOKEN_BUILD)/Makefile: $(TOOLCHAIN_BUILT) $(STOKEN_SRC)/configure $(TOMCRYPT_DEPS)
	mkdir -p $(STOKEN_BUILD)
	cd $(STOKEN_BUILD) && ../../$(STOKEN_SRC)/configure $(CONFIGURE_ARGS) \
		--without-gtk

$(STOKEN_BUILD)/libstoken.la: $(STOKEN_BUILD)/Makefile
	$(MAKE) -C $(STOKEN_BUILD)

$(OC_SYSROOT)/lib/libstoken.la: $(STOKEN_BUILD)/libstoken.la
	$(MAKEINSTALL) -C $(STOKEN_BUILD) install

STOKEN_DEPS := $(OC_SYSROOT)/lib/libstoken.la

stoken: $(STOKEN_DEPS)


#####################################################################
#
# Build liboath
#
OATH_VER := 2.4.0
OATH_TAR := oath-toolkit-$(OATH_VER).tar.gz
OATH_SHA1 := 89d2cd30dd401a3f6973ec3c2b26f1cb737764a7
OATH_SRC := sources/oath-toolkit-$(OATH_VER)
OATH_BUILD := $(TRIPLET)/oath

$(OATH_TAR):
	$(FETCH) $@ $(OATH_SHA1)

$(OATH_SRC)/configure: $(OATH_TAR)
	mkdir -p sources
	tar xfz $< -C sources
	cd $(OATH_SRC) && patch -p1 < ../../0001-fflush-freadahead-fseeko-Fix-for-Android.patch
	touch $@

$(OATH_BUILD)/Makefile: $(TOOLCHAIN_BUILT) $(OATH_SRC)/configure
	mkdir -p $(OATH_BUILD)
	cd $(OATH_BUILD) && ../../$(OATH_SRC)/configure $(CONFIGURE_ARGS) \
		--disable-pskc --disable-pam

$(OATH_BUILD)/liboath.la: $(OATH_BUILD)/Makefile
	$(MAKE) -C $(OATH_BUILD)

$(OC_SYSROOT)/lib/liboath.la: $(OATH_BUILD)/liboath.la
	$(MAKEINSTALL) -C $(OATH_BUILD) install

OATH_DEPS := $(OC_SYSROOT)/lib/liboath.la

oath: $(OATH_DEPS)


#####################################################################
#
# Build OpenConnect for Android
#
OPENCONNECT_SRC := ..
OPENCONNECT_BUILD := $(TRIPLET)/openconnect

$(OPENCONNECT_SRC)/configure:
	cd $(OPENCONNECT_SRC) && ./autogen.sh

$(OPENCONNECT_BUILD)/Makefile: $(TOOLCHAIN_BUILT) $(GNUTLS_DEPS) $(LIBXML_DEPS) $(STOKEN_DEPS) $(OATH_DEPS) $(OPENCONNECT_SRC)/configure
	mkdir -p $(OPENCONNECT_BUILD)
	cd $(OPENCONNECT_BUILD) && ../../../configure \
	--host=$(TRIPLET) --prefix=/ \
	CFLAGS="$(EXTRA_CFLAGS)" \
	LDFLAGS="$(EXTRA_LDFLAGS)" \
	GNUTLS_LIBS="$(shell PKG_CONFIG_LIBDIR=$(OC_SYSROOT)/lib/pkgconfig pkg-config --static --libs gnutls)" \

=== debian/changelog ===
openconnect (6.00-2+deb8u2) jessie-security; urgency=high

  * Backport patch to fix CVE-2020-12823 (Closes: #960620)
  * Add myself to Uploaders
  * Update Vcs URLs in d/control

 -- Luca Boccassi <bluca@debian.org>  Thu, 14 May 2020 19:06:47 +0100

openconnect (6.00-2+deb8u1) jessie-security; urgency=high

  * Non-maintainer upload by the LTS Team.
  * CVE-2019-16239: Fix Buffer Overflow when a malicious server uses HTTP
    chunked encoding with crafted chunk sizes. (Closes: #940871)

 -- Roberto C. Sanchez <roberto@debian.org>  Thu, 03 Oct 2019 20:53:54 -0400

openconnect (6.00-2) unstable; urgency=medium

  * 01_fix-double-free.patch: Fix double free when PKCS#11 token does
    not include CA certs. (Closes: #781240) Thanks to Laurent Bigonville.

 -- Mike Miller <mtmiller@debian.org>  Thu, 26 Mar 2015 08:34:14 -0400

openconnect (6.00-1) unstable; urgency=medium

  * New upstream release, upload to unstable.
    - Fix regression breaking PKCS#11 token support. (Closes: #744214,
      LP: #1308054)
  * doc-remove-footer.patch: Remove, applied upstream.
  * Update libopenconnect3 shlibs and symbols files.

 -- Mike Miller <mtmiller@debian.org>  Tue, 08 Jul 2014 22:33:31 -0400

openconnect (5.99-2) experimental; urgency=medium

  * Build against GnuTLS 3.x, drop OpenSSL. (Closes: #742755)
    - Add Build-Depends on libgnutls28-dev rather than libgnutls-dev.
    - Drop Build-Depends on libssl-dev.
    - Remove OpenSSL-specific private function from libopenconnect3.symbols.
    - fix-gnutls-2.x-build.patch: Drop patch no longer needed when building
      against GnuTLS 3.x.
  * Add Depends on liboath-dev for libopenconnect-dev.
  * Add Build-Depends on libstoken-dev for RSA software token support.
  * Build openconnect-dbg and libopenconnect3-dbg debug symbol packages.
  * debian/rules: Back up and restore upstream files touched by dh-autoreconf.
  * debian/upstream/signing-key.asc: Store upstream PGP signing key in
    ASCII-armored format.
  * Run wrap-and-sort on debian/control and debian/*.install.

 -- Mike Miller <mtmiller@debian.org>  Thu, 03 Apr 2014 09:14:07 -0400

openconnect (5.99-1) experimental; urgency=medium

  * New upstream release.
  * Bump libopenconnect soname (2 -> 3) and update symbols file.
  * doc-remove-footer.patch: Refresh patch from upstream git commit.
  * fix-gnutls-2.x-build.patch: Cherry-pick from upstream git to fix building
    against GnuTLS 2.x.
  * debian/copyright: Refresh for new upstream release.

 -- Mike Miller <mtmiller@debian.org>  Thu, 06 Mar 2014 22:50:40 -0500

openconnect (5.03-1) unstable; urgency=medium

  * New upstream release.

 -- Mike Miller <mtmiller@debian.org>  Tue, 11 Feb 2014 22:43:03 -0500

=== debian/control ===
Source: openconnect
Section: net
Priority: optional
Maintainer: Mike Miller <mtmiller@debian.org>
Uploaders: Luca Boccassi <bluca@debian.org>
Build-Depends: debhelper (>= 9),
               dh-autoreconf,
               groff,
               libgnutls28-dev,
               liboath-dev,
               libp11-kit-dev,
               libproxy-dev,
               libstoken-dev,
               libxml2-dev,
               pkg-config,
               python,
               zlib1g-dev
Standards-Version: 3.9.5
Vcs-Browser: https://salsa.debian.org/debian/openconnect
Vcs-Git: https://salsa.debian.org/debian/openconnect.git
Homepage: http://www.infradead.org/openconnect/

Package: openconnect
Architecture: any
Depends: vpnc-scripts, ${misc:Depends}, ${shlibs:Depends}
Description: open client for Cisco AnyConnect VPN
 OpenConnect is a client for Cisco's AnyConnect SSL VPN, which is supported by
 the ASA5500 Series, by IOS 12.4(9)T or later on Cisco SR500, 870, 880, 1800,
 2800, 3800, 7200 Series and Cisco 7301 Routers, and probably others.

Package: openconnect-dbg
Section: debug
Architecture: any
Priority: extra
Depends: openconnect (= ${binary:Version}), ${misc:Depends}
Description: debugging symbols for the OpenConnect VPN client
 OpenConnect is a client for Cisco's AnyConnect SSL VPN, which is supported by
 the ASA5500 Series, by IOS 12.4(9)T or later on Cisco SR500, 870, 880, 1800,
 2800, 3800, 7200 Series and Cisco 7301 Routers, and probably others.
 .
 This package contains the debugging symbols for openconnect.

Package: libopenconnect-dev
Section: libdevel
Architecture: any
Multi-Arch: same
Depends: libgnutls28-dev,
         liboath-dev,
         libopenconnect3 (= ${binary:Version}),
         libp11-kit-dev,
         libproxy-dev,
         libstoken-dev,
         libxml2-dev,
         zlib1g-dev,
         ${misc:Depends}
Description: open client for Cisco AnyConnect VPN - development files
 OpenConnect is a client for Cisco's AnyConnect SSL VPN, which is supported by
 the ASA5500 Series, by IOS 12.4(9)T or later on Cisco SR500, 870, 880, 1800,
 2800, 3800, 7200 Series and Cisco 7301 Routers, and probably others.
 .
 This package provides the header and development files.

Package: libopenconnect3
Section: libs
Architecture: any
Multi-Arch: same
Pre-Depends: ${misc:Pre-Depends}
Depends: ${misc:Depends}, ${shlibs:Depends}
Recommends: ca-certificates
Description: open client for Cisco AnyConnect VPN - shared library
 OpenConnect is a client for Cisco's AnyConnect SSL VPN, which is supported by
 the ASA5500 Series, by IOS 12.4(9)T or later on Cisco SR500, 870, 880, 1800,
 2800, 3800, 7200 Series and Cisco 7301 Routers, and probably others.
 .
 This package provides the shared library.

Package: libopenconnect3-dbg
Section: debug
Architecture: any
Priority: extra
Multi-Arch: same
Depends: libopenconnect3 (= ${binary:Version}), ${misc:Depends}
Description: debugging symbols for the libopenconnect3 shared library
 OpenConnect is a client for Cisco's AnyConnect SSL VPN, which is supported by
 the ASA5500 Series, by IOS 12.4(9)T or later on Cisco SR500, 870, 880, 1800,
 2800, 3800, 7200 Series and Cisco 7301 Routers, and probably others.
 .
 This package contains the debugging symbols for libopenconnect3.

=== debian/watch ===
version=3
opts=pgpsigurlmangle=s/$/.asc/ \
ftp://ftp.infradead.org/pub/openconnect/openconnect-(.*)\.tar\.gz

## openconnect 7.06

=== debian/changelog ===
openconnect (7.06-2build2) xenial; urgency=medium

  * No-change rebuild for gnutls transition.

 -- Matthias Klose <doko@ubuntu.com>  Wed, 17 Feb 2016 22:26:58 +0000

openconnect (7.06-2build1) wily; urgency=medium

  * No change rebuild for gcc transition

 -- Jonathan Riddell <jriddell@ubuntu.com>  Mon, 10 Aug 2015 18:00:18 +0200

openconnect (7.06-2) unstable; urgency=medium

  * Upload to unstable.

 -- Mike Miller <mtmiller@debian.org>  Mon, 25 May 2015 17:32:01 -0400

openconnect (7.06-1) experimental; urgency=medium

  * New upstream release. (Closes: #776235)
  * Bump libopenconnect soname (3 -> 5) and update symbols file.
  * Add Build-Depends on liblz4-dev for LZ4 compression.
  * debian/rules:
    - Update list of distributed files to back up and restore.
    - Ensure version.c gets the right upstream or Debian version string.
    - Allow build rules to work on a git snapshot tree.
  * debian/copyright: Refresh for new upstream release.
  * Bump Standards-Version to 3.9.6. No changes needed.

 -- Mike Miller <mtmiller@debian.org>  Sun, 05 Apr 2015 23:12:29 -0400

=== debian/control ===
--- 
+++ 
@@ -2,11 +2,11 @@
 Section: net
 Priority: optional
 Maintainer: Mike Miller <mtmiller@debian.org>
-Uploaders: Luca Boccassi <bluca@debian.org>
 Build-Depends: debhelper (>= 9),
                dh-autoreconf,
                groff,
                libgnutls28-dev,
+               liblz4-dev,
                liboath-dev,
                libp11-kit-dev,
                libproxy-dev,
@@ -15,9 +15,9 @@
                pkg-config,
                python,
                zlib1g-dev
-Standards-Version: 3.9.5
-Vcs-Browser: https://salsa.debian.org/debian/openconnect
-Vcs-Git: https://salsa.debian.org/debian/openconnect.git
+Standards-Version: 3.9.6
+Vcs-Git: git://anonscm.debian.org/collab-maint/openconnect.git
+Vcs-Browser: http://anonscm.debian.org/gitweb/?p=collab-maint/openconnect.git
 Homepage: http://www.infradead.org/openconnect/
 
 Package: openconnect
@@ -46,7 +46,7 @@
 Multi-Arch: same
 Depends: libgnutls28-dev,
          liboath-dev,
-         libopenconnect3 (= ${binary:Version}),
+         libopenconnect5 (= ${binary:Version}),
          libp11-kit-dev,
          libproxy-dev,
          libstoken-dev,
@@ -60,7 +60,7 @@
  .
  This package provides the header and development files.
 
-Package: libopenconnect3
+Package: libopenconnect5
 Section: libs
 Architecture: any
 Multi-Arch: same
@@ -74,15 +74,15 @@
  .
  This package provides the shared library.
 
-Package: libopenconnect3-dbg
+Package: libopenconnect5-dbg
 Section: debug
 Architecture: any
 Priority: extra
 Multi-Arch: same
-Depends: libopenconnect3 (= ${binary:Version}), ${misc:Depends}
-Description: debugging symbols for the libopenconnect3 shared library
+Depends: libopenconnect5 (= ${binary:Version}), ${misc:Depends}
+Description: debugging symbols for the libopenconnect5 shared library
  OpenConnect is a client for Cisco's AnyConnect SSL VPN, which is supported by
  the ASA5500 Series, by IOS 12.4(9)T or later on Cisco SR500, 870, 880, 1800,
  2800, 3800, 7200 Series and Cisco 7301 Routers, and probably others.
  .
- This package contains the debugging symbols for libopenconnect3.
+ This package contains the debugging symbols for libopenconnect5.

=== debian/rules ===
#!/usr/bin/make -f

AUTORECONF_SOURCES = aclocal.m4 config.guess config.sub configure ltmain.sh \
		     m4/libtool.m4 m4/ltoptions.m4 m4/ltsugar.m4 \
		     m4/ltversion.m4 m4/lt~obsolete.m4 missing Makefile.in \
		     po/Makefile.in www/Makefile.in \
		     www/images/Makefile.in www/inc/Makefile.in \
		     www/styles/Makefile.in
VERSION_UPSTREAM := $(shell sed -ne 's|.*AC_INIT[^,]*, *\([0-9.]\+\).*|\1|p' configure.ac)
VERSION_DEBIAN := $(shell dpkg-parsechangelog | sed -ne 's|^Version: *\(.*\)$$|\1|p')
export DEB_BUILD_MAINT_OPTIONS = hardening=+all
export V = 1

%:
	dh $@ --with autoreconf --list-missing

override_dh_auto_configure:
	dh_auto_configure -- \
		--disable-static \
		--with-gnutls \
		--htmldir=/usr/share/doc/openconnect/html \
		--with-system-cafile=/etc/ssl/certs/ca-certificates.crt \
		--with-vpnc-script=/usr/share/vpnc-scripts/vpnc-script
	# Ensure version.c gets the right version string, either the upstream
	# version if unmodified or the Debian version if building from a git
	# snapshot or if the source has been patched.
	[ -f version.c ] && cp -p version.c version.c.debian-backup \
	                 || touch version.c.debian-clean
	make version.c
	if ! grep '"v$(VERSION_UPSTREAM)"' version.c > /dev/null; then \
		sed -i -e 's|".*"|"v$(VERSION_DEBIAN)"|' version.c; \
	fi

override_dh_installchangelogs:
	dh_installchangelogs www/changelog.html

override_dh_compress:
	dh_compress -Xhtml/changelog.html

override_dh_strip:
	dh_strip -plibopenconnect5 --dbg-package=libopenconnect5-dbg
	dh_strip -popenconnect --dbg-package=openconnect-dbg

override_dh_autoreconf:
	for f in $(AUTORECONF_SOURCES); do \
		[ ! -f $$f ] || [ -f $$f.debian-backup ] || mv $$f $$f.debian-backup; \
	done
	dh_autoreconf

override_dh_autoreconf_clean:
	dh_autoreconf_clean
	for f in $(AUTORECONF_SOURCES); do \
		[ ! -f $$f.debian-backup ] || mv $$f.debian-backup $$f; \
	done
	[ ! -f version.c.debian-backup ] || mv version.c.debian-backup version.c
	[ ! -f version.c.debian-clean ] || rm -f version.c.debian-clean version.c

## openconnect 7.08

=== android/Makefile ===
--- 
+++ 
@@ -10,7 +10,7 @@
 #
 # It should also be fairly simple to extend this to cross-compile for any target
 
-NDK     := /opt/android-sdk-linux_x86/android-ndk-r9b/
+NDK     := /opt/android-sdk-linux_x86/android-ndk-r10d/
 ARCH    := arm
 
 # You should be able to just 'make ARCH=x86' and it should DTRT.
@@ -43,6 +43,9 @@
 
 export PATH PKG_CONFIG_LIBDIR
 
+# PKG_CONFIG_LIBDIR gets exported to sub-makes, but not to $(shell
+PKG_CONFIG := PKG_CONFIG_LIBDIR=$(PKG_CONFIG_LIBDIR) pkg-config
+
 MAKEINSTALL=$(MAKE) INSTALL=$(TOPDIR)/install_symlink.sh
 FETCH=$(TOPDIR)/fetch.sh
 
@@ -52,14 +55,14 @@
 
 SOURCE_LIST = $(LIBXML2_SRC)/configure $(GMP_SRC)/configure \
 	$(NETTLE_SRC)/configure $(GNUTLS_SRC)/configure \
-	$(TOMCRYPT_DIR)/makefile $(STOKEN_SRC)/configure \
-	$(OATH_SRC)/configure
-
-PKG_LIST := LIBXML2 OPENSSL GMP NETTLE GNUTLS TOMCRYPT STOKEN OATH
+	$(STOKEN_SRC)/configure $(OATH_SRC)/configure \
+	$(LZ4_DIR)/Makefile
+
+PKG_LIST := LIBXML2 OPENSSL GMP NETTLE GNUTLS STOKEN OATH LZ4
 
 MIRROR_TEST_TARGETS := $(addprefix mirror-test-,$(PKG_LIST))
 
-all: openconnect
+all: openconnect run_pie
 
 #####################################################################
 #
@@ -98,7 +101,7 @@
 	cd $(LIBXML2_BUILD) && ../../$(LIBXML2_SRC)/configure $(CONFIGURE_ARGS) \
 	    --without-c14n -without-catalog --without-debug --without-docbook \
 	    --without-fexceptions --without-ftp --without-history \
-	    --without-html --without-http --without-iconv --without-iconv \
+	    --without-http --without-iconv --without-iconv \
 	    --without-iso8859x --without-legacy --without-pattern \
 	    --without-push --without-regexps --without-run-debug \
 	    --without-sax1 --without-schemas --without-schematron \
@@ -198,9 +201,9 @@
 #
 # Build nettle
 #
-NETTLE_VER := 2.7
+NETTLE_VER := 2.7.1
 NETTLE_TAR := nettle-$(NETTLE_VER).tar.gz
-NETTLE_SHA1 := e17de3678b987841e88a724b7d2f6856d97ab139
+NETTLE_SHA1 := e7477df5f66e650c4c4738ec8e01c2efdb5d1211
 NETTLE_SRC := sources/nettle-$(NETTLE_VER)
 NETTLE_BUILD := $(TRIPLET)/nettle
 
@@ -231,9 +234,9 @@
 #
 # Build GnuTLS
 #
-GNUTLS_VER := 3.2.15
+GNUTLS_VER := 3.2.21
 GNUTLS_TAR := gnutls-$(GNUTLS_VER).tar.xz
-GNUTLS_SHA1 := 31f289b48b0bf054f5f8c16d3b878615d0ae06fc
+GNUTLS_SHA1 := fa12e643ad21bcaf450d534f262c813d75843966
 GNUTLS_SRC := sources/gnutls-$(GNUTLS_VER)
 GNUTLS_BUILD := $(TRIPLET)/gnutls
 
@@ -278,47 +281,11 @@
 
 #####################################################################
 #
-# Build libtomcrypt
-#
-TOMCRYPT_VER := 1.17
-TOMCRYPT_TAR := crypt-$(TOMCRYPT_VER).tar.bz2
-TOMCRYPT_SHA1 := 9c746822c84e4276e432b64964f94d1d5ddd13ad
-TOMCRYPT_DIR := $(TRIPLET)/libtomcrypt-$(TOMCRYPT_VER)
-
-$(TOMCRYPT_TAR):
-	$(FETCH) $@ $(TOMCRYPT_SHA1)
-
-$(TOMCRYPT_DIR)/makefile: $(TOMCRYPT_TAR)
-	mkdir -p $(TRIPLET)
-	tar xfj $< -C $(TRIPLET)
-	touch $@
-
-$(TOMCRYPT_DIR)/libtomcrypt.a: $(TOOLCHAIN_BUILT) $(TOMCRYPT_DIR)/makefile
-	$(MAKE) -C $(TOMCRYPT_DIR) \
-		CC="$(TRIPLET)-gcc $(EXTRA_CFLAGS)" \
-		AR="$(TRIPLET)-ar" \
-		RANLIB="$(TRIPLET)-ranlib"
-
-$(OC_SYSROOT)/lib/libtomcrypt.a: $(TOMCRYPT_DIR)/libtomcrypt.a
-	$(MAKE) -C $(TOMCRYPT_DIR) \
-		DESTDIR=$(OC_SYSROOT) \
-		LIBPATH=/lib INCPATH=/include \
-		INSTALL_USER=$(shell id -u) \
-		INSTALL_GROUP=$(shell id -g) \
-		NODOCS=1 install
-
-TOMCRYPT_DEPS := $(OC_SYSROOT)/lib/libtomcrypt.a
-
-tomcrypt: $(TOMCRYPT_DEPS)
-
-
-#####################################################################
-#
 # Build libstoken
 #
-STOKEN_VER := 0.5
+STOKEN_VER := 0.81
 STOKEN_TAR := stoken-$(STOKEN_VER).tar.gz
-STOKEN_SHA1 := 1fcc026580a3cf28904212f34ae2cf2180586f86
+STOKEN_SHA1 := db36aec5a8bd3f5f92deaebdea08cb639b78da73
 STOKEN_SRC := sources/stoken-$(STOKEN_VER)
 STOKEN_BUILD := $(TRIPLET)/stoken
 
@@ -330,7 +297,7 @@
 	tar xfz $< -C sources
 	touch $@
 
-$(STOKEN_BUILD)/Makefile: $(TOOLCHAIN_BUILT) $(STOKEN_SRC)/configure $(TOMCRYPT_DEPS)
+$(STOKEN_BUILD)/Makefile: $(TOOLCHAIN_BUILT) $(STOKEN_SRC)/configure $(NETTLE_DEPS)
 	mkdir -p $(STOKEN_BUILD)
 	cd $(STOKEN_BUILD) && ../../$(STOKEN_SRC)/configure $(CONFIGURE_ARGS) \
 		--without-gtk
@@ -350,9 +317,9 @@
 #
 # Build liboath
 #
-OATH_VER := 2.4.0
+OATH_VER := 2.4.1
 OATH_TAR := oath-toolkit-$(OATH_VER).tar.gz
-OATH_SHA1 := 89d2cd30dd401a3f6973ec3c2b26f1cb737764a7
+OATH_SHA1 := b0ca4c5f89c12c550f7227123c2f21f45b2bf969
 OATH_SRC := sources/oath-toolkit-$(OATH_VER)
 OATH_BUILD := $(TRIPLET)/oath
 
@@ -370,16 +337,46 @@
 	cd $(OATH_BUILD) && ../../$(OATH_SRC)/configure $(CONFIGURE_ARGS) \
 		--disable-pskc --disable-pam
 
-$(OATH_BUILD)/liboath.la: $(OATH_BUILD)/Makefile
+$(OATH_BUILD)/liboath/liboath.la: $(OATH_BUILD)/Makefile
 	$(MAKE) -C $(OATH_BUILD)
 
-$(OC_SYSROOT)/lib/liboath.la: $(OATH_BUILD)/liboath.la
+$(OC_SYSROOT)/lib/liboath.la: $(OATH_BUILD)/liboath/liboath.la
 	$(MAKEINSTALL) -C $(OATH_BUILD) install
 
 OATH_DEPS := $(OC_SYSROOT)/lib/liboath.la
 
 oath: $(OATH_DEPS)
 
+
+#####################################################################
+#
+# Build liblz4
+#
+LZ4_VER := r127
+LZ4_TAR := lz4-$(LZ4_VER).tar.gz
+LZ4_SHA1 := 1aa7d4bb62eb79f88b33f86f9890dc9f96797af5
+LZ4_DIR := $(TRIPLET)/lz4-$(LZ4_VER)
+
+$(LZ4_TAR):
+	$(FETCH) $@ $(LZ4_SHA1)
+
+$(LZ4_DIR)/Makefile: $(LZ4_TAR)
+	mkdir -p $(TRIPLET)
+	tar xzf $< -C $(TRIPLET)
+	touch $@
+
+$(OC_SYSROOT)/lib/liblz4.a: $(TOOLCHAIN_BUILT) $(LZ4_DIR)/Makefile
+	$(MAKE) -C $(LZ4_DIR)/lib \
+		CC="$(TRIPLET)-gcc $(EXTRA_CFLAGS)" \
+		AR="$(TRIPLET)-ar" \
+		LIBDIR=$(OC_SYSROOT)/lib \
+		INCLUDEDIR=$(OC_SYSROOT)/include \
+		install
+	rm -f $(OC_SYSROOT)/lib/liblz4.so*
+
+LZ4_DEPS := $(OC_SYSROOT)/lib/liblz4.a
+
+lz4: $(LZ4_DEPS)
 
 #####################################################################
 #
@@ -391,10 +388,13 @@
 $(OPENCONNECT_SRC)/configure:
 	cd $(OPENCONNECT_SRC) && ./autogen.sh
 
-$(OPENCONNECT_BUILD)/Makefile: $(TOOLCHAIN_BUILT) $(GNUTLS_DEPS) $(LIBXML_DEPS) $(STOKEN_DEPS) $(OATH_DEPS) $(OPENCONNECT_SRC)/configure
+$(OPENCONNECT_BUILD)/Makefile: $(TOOLCHAIN_BUILT) $(GNUTLS_DEPS) $(LIBXML_DEPS) \
+		$(STOKEN_DEPS) $(OATH_DEPS) $(LZ4_DEPS) $(OPENCONNECT_SRC)/configure
 	mkdir -p $(OPENCONNECT_BUILD)
 	cd $(OPENCONNECT_BUILD) && ../../../configure \
 	--host=$(TRIPLET) --prefix=/ \
-	CFLAGS="$(EXTRA_CFLAGS)" \
-	LDFLAGS="$(EXTRA_LDFLAGS)" \
-	GNUTLS_LIBS="$(shell PKG_CONFIG_LIBDIR=$(OC_SYSROOT)/lib/pkgconfig pkg-config --static --libs gnutls)" \
+	CFLAGS="$(EXTRA_CFLAGS) -fvisibility=default -fPIE" \
+	LDFLAGS="$(EXTRA_LDFLAGS) -rdynamic -pie" \
+	GNUTLS_LIBS="$(shell $(PKG_CONFIG) --static --libs gnutls)" \
+	LIBSTOKEN_LIBS="$(shell $(PKG_CONFIG) --static --libs stoken)" \
+	--enable-shared --with-vpnc-script=/etc/vpnc/vpnc-script \

=== debian/changelog ===
openconnect (7.08-3ubuntu0.18.04.2) bionic-security; urgency=medium

  * SECURITY UPDATE: Buffer overflow vulnerability
    - d/p/Fix-buffer-overflow-with-chunked-HTTP-handling-CVE-2.patch: Buffer
      overflow with chunked HTTP handling.
    - CVE-2019-16239
  * SECURITY UPDATE: Fix crash when HTTP has timeout
    - d/p/Close-HTTPS-connection-on-failure-returns-from-proce.patch: HTTPS
      connection on failure returns from process_http_response().

 -- Paulo Flabiano Smorigo <pfsmorigo@canonical.com>  Tue, 29 Sep 2020 19:05:41 +0000

openconnect (7.08-3ubuntu0.18.04.1) bionic; urgency=medium

  * debian/patches/git-juniper-realm.patch:
    - Fix issue causing front-ends/GUIs to be insensitive to changes 
      in the Juniper realm dropdown (lp: #1764047)

 -- Sebastien Bacher <seb128@ubuntu.com>  Fri, 15 Mar 2019 00:23:01 +0100

openconnect (7.08-3) unstable; urgency=medium

  * d/p/add-logout-juniper.patch: New patch, add logout to Juniper VPN.
    Thanks to Daniel Lenski (LP: #1655279)

 -- Mike Miller <mtmiller@debian.org>  Sun, 25 Feb 2018 15:00:56 -0800

openconnect (7.08-2) unstable; urgency=medium

  * d/p/fix-ftbfs-ipv6-tclass-undeclared.patch: New patch, fix FTBFS on GNU/Hurd
  * d/control, d/rules: Migrate to automatic dbgsym packages
  * Bump debhelper compatibility level to 11
  * d/copyright: Bump copyright to 2018 for debian/*
  * d/control:
    - Mention Pulse Connect and Juniper in Description (Closes: #881338)
    - Update Vcs-* fields for migration to salsa.d.o
    - Bump Standards-Version to 4.1.3, no changes needed

 -- Mike Miller <mtmiller@debian.org>  Fri, 23 Feb 2018 15:28:37 -0800

openconnect (7.08-1) unstable; urgency=medium

  * New upstream version 7.08
    - Fix MTU detection (Closes: #847135)
  * d/libopenconnect5.{shlibs,symbols}: Update for new release
  * d/p/juniper-content-length.patch: Drop, applied upstream
  * d/p/fix-tests-shell-syntax.patch: Fix test suite shell bashisms
  * d/p/softhsm2-module-workaround.patch: Hard-code Debian location of
    libsofthsm2.so
  * d/control:
    - Add Build-Depends: libsocket-wrapper, libuid-wrapper, ocserv, openssl, and
      softhsm2 for test suite
    - Add Build-Depends: libpcsclite-dev to enable Yubikey support
      (LP: #1649227)
    - Add Build-Depends: dpkg-dev (>= 1.17.14) for build profiles support
    - Drop obsolete Build-Depends: liboath-dev
    - Reorder fields according to "cme fix dpkg-control"
  * Bump debhelper compatibility level to 10
  * Drop explicit dependency on dh-autoreconf and disabling silent rules, now
    enabled by default

 -- Mike Miller <mtmiller@debian.org>  Sat, 24 Dec 2016 10:50:15 -0800

openconnect (7.07-2) unstable; urgency=medium

  * d/rules: Build with --as-needed to remove indirect lib dependencies
  * d/control: Add Depends: liblz4-dev for libopenconnect-dev (Closes: 846706)
  * d/control: Use canonical repository URL for Vcs-Browser
  * d/copyright: Refresh copyright information
  * d/copyright: Update Format using "cme fix dpkg-copyright"

 -- Mike Miller <mtmiller@debian.org>  Thu, 08 Dec 2016 15:05:19 -0800

openconnect (7.07-1) unstable; urgency=medium

  * New upstream release.
    - Fix spelling of "sí" in Spanish translation. (Closes: #792073)
    - Fix handling of KMP message with --juniper. (Closes: #833466)
  * Add Build-Depends on libkrb5-dev, enables GSSAPI support. (Closes: #830905)
  * d/p/juniper-content-length.patch: Add Content-Length header to mimic
    official pulse client. (Closes: #845184)
  * Update libopenconnect5 shlibs and symbols files.
  * debian/rules: Update list of distributed files to back up and restore.
  * Use https URI for Vcs-* control fields.
  * Bump Standards-Version to 3.9.8. No changes needed.

 -- Mike Miller <mtmiller@debian.org>  Fri, 25 Nov 2016 12:22:01 -0800

=== debian/control ===
Source: openconnect
Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
XSBC-Original-Maintainer: Mike Miller <mtmiller@debian.org>
Section: net
Priority: optional
Build-Depends: debhelper (>= 11),
               dpkg-dev (>= 1.17.14),
               groff,
               libgnutls28-dev,
               libkrb5-dev,
               liblz4-dev,
               libp11-kit-dev,
               libpcsclite-dev,
               libproxy-dev,
               libsocket-wrapper [!hurd-i386] <!nocheck>,
               libstoken-dev,
               libuid-wrapper [!alpha !hurd-i386 !kfreebsd-amd64 !kfreebsd-i386] <!nocheck>,
               libxml2-dev,
               ocserv [!hurd-i386 !kfreebsd-amd64 !kfreebsd-i386] <!nocheck>,
               openssl <!nocheck>,
               pkg-config,
               python,
               softhsm2 [!hurd-i386] <!nocheck>,
               zlib1g-dev
Standards-Version: 4.1.3
Vcs-Browser: https://salsa.debian.org/debian/openconnect
Vcs-Git: https://salsa.debian.org/debian/openconnect.git
Homepage: http://www.infradead.org/openconnect/

Package: openconnect
Architecture: any
Depends: vpnc-scripts, ${misc:Depends}, ${shlibs:Depends}
Description: open client for Cisco AnyConnect VPN
 OpenConnect is a client for Cisco's AnyConnect SSL VPN, which is supported by
 the ASA5500 Series, by IOS 12.4(9)T or later on Cisco SR500, 870, 880, 1800,
 2800, 3800, 7200 Series and Cisco 7301 Routers, and probably others.
 OpenConnect also supports the Pulse Connect Secure SSL VPN, formerly known as
 the Juniper SSL VPN or the Junos Pulse VPN.

Package: libopenconnect-dev
Architecture: any
Multi-Arch: same
Section: libdevel
Depends: libgnutls28-dev,
         liblz4-dev,
         libopenconnect5 (= ${binary:Version}),
         libp11-kit-dev,
         libpcsclite-dev,
         libproxy-dev,
         libstoken-dev,
         libxml2-dev,
         zlib1g-dev,
         ${misc:Depends}
Description: open client for Cisco AnyConnect VPN - development files
 OpenConnect is a client for Cisco's AnyConnect SSL VPN, which is supported by
 the ASA5500 Series, by IOS 12.4(9)T or later on Cisco SR500, 870, 880, 1800,
 2800, 3800, 7200 Series and Cisco 7301 Routers, and probably others.
 OpenConnect also supports the Pulse Connect Secure SSL VPN, formerly known as
 the Juniper SSL VPN or the Junos Pulse VPN.
 .
 This package provides the header and development files.

Package: libopenconnect5
Architecture: any
Multi-Arch: same
Section: libs
Depends: ${misc:Depends}, ${shlibs:Depends}
Recommends: ca-certificates
Pre-Depends: ${misc:Pre-Depends}
Description: open client for Cisco AnyConnect VPN - shared library
 OpenConnect is a client for Cisco's AnyConnect SSL VPN, which is supported by
 the ASA5500 Series, by IOS 12.4(9)T or later on Cisco SR500, 870, 880, 1800,
 2800, 3800, 7200 Series and Cisco 7301 Routers, and probably others.
 OpenConnect also supports the Pulse Connect Secure SSL VPN, formerly known as
 the Juniper SSL VPN or the Junos Pulse VPN.
 .
 This package provides the shared library.

=== debian/rules ===
--- 
+++ 
@@ -1,18 +1,21 @@
 #!/usr/bin/make -f
 
-AUTORECONF_SOURCES = aclocal.m4 config.guess config.sub configure ltmain.sh \
-		     m4/libtool.m4 m4/ltoptions.m4 m4/ltsugar.m4 \
+AUTORECONF_SOURCES = aclocal.m4 config.guess config.sub configure install-sh \
+		     ltmain.sh m4/libtool.m4 m4/ltoptions.m4 m4/ltsugar.m4 \
 		     m4/ltversion.m4 m4/lt~obsolete.m4 missing Makefile.in \
-		     po/Makefile.in www/Makefile.in \
+		     po/Makefile.in tests/Makefile.in www/Makefile.in \
 		     www/images/Makefile.in www/inc/Makefile.in \
 		     www/styles/Makefile.in
 VERSION_UPSTREAM := $(shell sed -ne 's|.*AC_INIT[^,]*, *\([0-9.]\+\).*|\1|p' configure.ac)
 VERSION_DEBIAN := $(shell dpkg-parsechangelog | sed -ne 's|^Version: *\(.*\)$$|\1|p')
+
 export DEB_BUILD_MAINT_OPTIONS = hardening=+all
-export V = 1
+
+# Link with --as-needed to eliminate unused or indirect library dependencies
+export DEB_LDFLAGS_MAINT_APPEND = -Wl,--as-needed
 
 %:
-	dh $@ --with autoreconf --list-missing
+	dh $@ --list-missing
 
 override_dh_auto_configure:
 	dh_auto_configure -- \
@@ -38,14 +41,14 @@
 	dh_compress -Xhtml/changelog.html
 
 override_dh_strip:
-	dh_strip -plibopenconnect5 --dbg-package=libopenconnect5-dbg
-	dh_strip -popenconnect --dbg-package=openconnect-dbg
+	dh_strip -plibopenconnect5 --dbgsym-migration='libopenconnect5-dbg (<< 7.08-2~)'
+	dh_strip -popenconnect --dbgsym-migration='openconnect-dbg (<< 7.08-2~)'
 
 override_dh_autoreconf:
 	for f in $(AUTORECONF_SOURCES); do \
 		[ ! -f $$f ] || [ -f $$f.debian-backup ] || mv $$f $$f.debian-backup; \
 	done
-	dh_autoreconf
+	dh_autoreconf --as-needed
 
 override_dh_autoreconf_clean:
 	dh_autoreconf_clean

## openconnect 8.02

=== debian/changelog ===
openconnect (8.02-1+deb10u1) buster-security; urgency=high

  * Non-maintainer upload by the Security Team.
  * Close HTTPS connection on failure returns from process_http_response()
  * Fix buffer overflow with chunked HTTP handling (CVE-2019-16239)
    (Closes: #940871)

 -- Salvatore Bonaccorso <carnil@debian.org>  Sun, 19 Jan 2020 00:05:50 +0100

openconnect (8.02-1) unstable; urgency=medium

  [ Mike Miller ]
  * New upstream version 8.02
  * d/p/fix-ftbfs-ipv6-tclass-undeclared.patch: Drop patch, applied upstream
  * d/u/signing-key.asc: Use export-minimal to compact upstream release
    signing key
  * d/watch: Bump format version to 4
  * Add autopkgtest to run the upstream test suite

  [ Daniel Lenski ]
  * Update package descriptions to reflect multi-protocol support

 -- Mike Miller <mtmiller@debian.org>  Fri, 25 Jan 2019 23:11:38 -0800

openconnect (8.01-1) unstable; urgency=medium

  * New upstream version 8.01 (Closes: #918529)
  * Drop patches applied upstream or no longer needed
    - d/p/add-logout-juniper.patch, applied upstream
    - d/p/fix-tests-shell-syntax.patch, applied upstream
    - d/p/softhsm2-module-workaround.patch, no longer needed
  * d/libopenconnect5.{shlibs,symbols}: Update for new release
  * d/libopenconnect5.symbols: Add Build-Depends-Package field
  * d/openconnect.install: Include usr/libexec/openconnect shell scripts
  * d/copyright: Refresh copyright information for new upstream release
  * Add Build-Depends on libgcrypt20-dev, libtasn1-6-dev, and libtss2-dev
  * Update Build-Depends on ocserv (>= 0.12.1-2) to fix failing unit tests
    (Closes: #917715)
  * Add Build-Depends on locales-all <!nocheck> for new test
  * Add Build-Depends on debhelper-compat, delete d/compat
  * Bump debhelper compatibility level to 12
  * d/rules:
    - Build with --disable-dsa-tests to skip DSA keys in unit tests
    - Drop unsupported dh --list-missing option
    - Include /usr/share/dpkg/pkg-info.mk for package version
    - Drop cruft trying to save and restore generated source files
    - Drop obsolete configure options --disable-static and --with-system-cafile
  * d/clean: Delete autogenerated version.c on clean
  * d/s/options: Ignore changes to tokens as a side effect of running tests
  * Bump Standards-Version to 4.3.0, no changes needed

 -- Mike Miller <mtmiller@debian.org>  Thu, 10 Jan 2019 11:54:02 -0800

=== debian/rules ===
#!/usr/bin/make -f

include /usr/share/dpkg/pkg-info.mk

export DEB_BUILD_MAINT_OPTIONS = hardening=+all

# Link with --as-needed to eliminate unused or indirect library dependencies
export DEB_LDFLAGS_MAINT_APPEND = -Wl,--as-needed

%:
	dh $@

override_dh_auto_configure:
	dh_auto_configure -- \
		--disable-dsa-tests \
		--htmldir=/usr/share/doc/openconnect/html \
		--with-gnutls \
		--with-vpnc-script=/usr/share/vpnc-scripts/vpnc-script
	$(MAKE) version.c
	sed -i -e 's|".*"|"v$(DEB_VERSION)"|' version.c

override_dh_installchangelogs:
	dh_installchangelogs www/changelog.html

override_dh_compress:
	dh_compress -Xhtml/changelog.html

override_dh_strip:
	dh_strip -plibopenconnect5 --dbgsym-migration='libopenconnect5-dbg (<< 7.08-2~)'
	dh_strip -popenconnect --dbgsym-migration='openconnect-dbg (<< 7.08-2~)'

override_dh_autoreconf:
	dh_autoreconf --as-needed

## openconnect 8.02.1

=== debian/changelog ===
openconnect (8.02.1-1+dde) unstable; urgency=low

  * ['Autobuild release-candidate: 4b133f2b3a9642f5bb89d3d1420b351dbaebcfba']

 -- shuttle <shuttle@deepin.com>  Wed, 29 Jul 2020 19:46:55 +0000
